<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item :label="t('keyword.form.content')" prop="content">
              <el-input v-model="queryParams.content" :placeholder="t('keyword.form.contentPlaceholder')" clearable
                @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">{{ t('keyword.button.search') }}</el-button>
              <el-button icon="Refresh" @click="resetQuery">{{ t('keyword.button.reset') }}</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10">
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:keyword:add']" type="primary" plain icon="Plus" @click="handleAdd">{{
              t('keyword.button.add') }}</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:keyword:edit']" type="success" plain :disabled="single" icon="Edit"
              @click="handleUpdate()">{{ t('keyword.button.edit') }}</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-has-permi="['setting:keyword:remove']" type="danger" plain :disabled="multiple" icon="Delete"
              @click="handleDelete()">{{ t('keyword.button.delete') }}</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-dropdown class="mt-[1px]">
              <el-button plain type="info">
                {{ t('keyword.button.more') }}
                <el-icon class="el-icon--right"><arrow-down /></el-icon>
              </el-button>
              <template #dropdown>
                <el-dropdown-menu>
                  <el-dropdown-item v-if="checkPermi(['setting:keyword:export'])" icon="Download"
                    @click="handleExport">{{ t('keyword.button.export') }}</el-dropdown-item>
                </el-dropdown-menu>
              </template>
            </el-dropdown>
          </el-col>
          <RightToolbar v-model:show-search="showSearch" :columns="columns" :search="true" @query-table="getList">
          </RightToolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="keywordList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column :label="t('keyword.table.id')" align="center" prop="id" v-if="true" width="100" />
        <el-table-column :label="t('keyword.table.content')" align="center" prop="content" />
        <el-table-column :label="t('keyword.table.note')" align="center" prop="note" />
        <el-table-column :label="t('keyword.table.action')" fixed="right" width="200"
          class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button v-has-permi="['setting:keyword:edit']" type="primary" icon="Edit"
              style="padding: 0 5px; font-size: 10px; height: 24px" @click="handleUpdate(scope.row)">
              {{ t('keyword.button.edit') }}
            </el-button>
            <el-button v-has-permi="['setting:keyword:remove']" type="danger" icon="Delete"
              style="padding: 0 5px; font-size: 10px; height: 24px" @click="handleDelete(scope.row)">
              {{ t('keyword.button.delete') }}
            </el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改文件夹关键词设置对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="keywordFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="t('keyword.form.content')" prop="content">
          <el-input v-model="form.content" :placeholder="t('keyword.form.contentPlaceholder')" />
        </el-form-item>
        <el-form-item :label="t('keyword.form.note')" prop="note">
          <el-input v-model="form.note" type="textarea" :placeholder="t('keyword.form.notePlaceholder')" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">{{ t('keyword.button.save')
          }}</el-button>
          <el-button @click="cancel">{{ t('keyword.button.cancel') }}</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Keyword" lang="ts">
import { ref, reactive, onMounted, getCurrentInstance, toRefs } from 'vue';
import { useI18n } from 'vue-i18n';
import { listKeyword, getKeyword, delKeyword, addKeyword, updateKeyword } from '@/api/setting/keyword';
import { KeywordVO, KeywordQuery, KeywordForm } from '@/api/setting/keyword/types';
import { checkPermi } from '@/utils/permission';
import RightToolbar from '@/components/RightToolbar/index.vue';
import { ArrowDown } from '@element-plus/icons-vue';

const { t } = useI18n();

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

// 类型定义
type DialogOption = {
  visible: boolean;
  title: string;
};

type ElFormInstance = any;

type PageData<T, Q> = {
  form: T;
  queryParams: Q;
  rules: any;
};

const keywordList = ref<KeywordVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const keywordFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

// 列显隐信息
const columns = ref([
  { key: 0, label: '序号', visible: true, children: [] },
  { key: 1, label: '文本', visible: true, children: [] },
  { key: 2, label: '备注', visible: true, children: [] },
  { key: 3, label: '操作', visible: true, children: [] }
]);

const initFormData: KeywordForm = {
  id: undefined,
  content: undefined,
  note: undefined,
}
const data = reactive<PageData<KeywordForm, KeywordQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    content: undefined,
    params: {
    }
  },
  rules: {
    id: [
      { required: true, message: "序号不能为空", trigger: "blur" }
    ],
    content: [
      { required: true, message: "文本不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询文件夹关键词设置列表 */
const getList = async () => {
  loading.value = true;
  const res = await listKeyword(queryParams.value);
  keywordList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  keywordFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: KeywordVO[]) => {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = t('keyword.dialog.add');
}

/** 修改按钮操作 */
const handleUpdate = async (row?: KeywordVO) => {
  reset();
  const _id = row?.id || ids.value[0]
  const res = await getKeyword(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = t('keyword.dialog.edit');
}

/** 提交按钮 */
const submitForm = () => {
  keywordFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateKeyword(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addKeyword(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess(t('keyword.message.saveSuccess'));
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: KeywordVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm(t('keyword.dialog.confirmDelete', { ids: _ids })).finally(() => loading.value = false);
  await delKeyword(_ids);
  proxy?.$modal.msgSuccess(t('keyword.message.deleteSuccess'));
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('setting/keyword/export', {
    ...queryParams.value
  }, `keyword_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
